version: '3.4'

services:
  php:
    image: ${PHP_IMAGE:?PHP_IMAGE is not set or empty}
    labels:
      - "com.centurylinklabs.watchtower.enable=true"
    restart: always
    depends_on:
      - db
    environment:
      - APP_DEBUG=${APP_DEBUG:-0}
      - APP_ENV=${APP_ENV:-prod}
      - APP_SECRET=${APP_SECRET:?APP_SECRET is not set or empty}
      - CORS_ALLOW_ORIGIN=${CORS_ALLOW_ORIGIN:?CORS_ALLOW_ORIGIN is not set or empty}
      - DATABASE_URL=${DATABASE_URL:?DATABASE_URL is not set or empty}
      - MERCURE_JWT_SECRET=${MERCURE_JWT_SECRET:?MERCURE_JWT_SECRET is not set or empty}
      - MERCURE_SUBSCRIBE_URL=${MERCURE_SUBSCRIBE_URL:?MERCURE_SUBSCRIBE_URL is not set or empty}
      - TRUSTED_HOSTS=${TRUSTED_HOSTS:?TRUSTED_HOSTS is not set or empty}
      - TRUSTED_PROXIES=${TRUSTED_PROXIES:-10.0.0.0/8,172.16.0.0/12,192.168.0.0/16}

  api:
    image: ${NGINX_IMAGE:?NGINX_IMAGE is not set or empty}
    labels:
      - "com.centurylinklabs.watchtower.enable=true"
    restart: always
    depends_on:
      - php
    ports:
      - target: 80
        published: 8080
        protocol: tcp

  cache-proxy:
    image: ${VARNISH_IMAGE:?VARNISH_IMAGE is not set or empty}
    labels:
      - "com.centurylinklabs.watchtower.enable=true"
    restart: always
    depends_on:
      - api
    tmpfs:
      - /usr/local/var/varnish:exec
    ports:
      - target: 80
        published: 8081
        protocol: tcp

  db:
    image: postgres:12-alpine
    labels:
      - "com.centurylinklabs.watchtower.enable=true"
    restart: always
    environment:
      - POSTGRES_DB=${POSTGRES_DB:-api}
      - POSTGRES_PASSWORD=${POSTGRES_PASSWORD:?POSTGRES_PASSWORD is not set or empty}
      - POSTGRES_USER=${POSTGRES_USER:-api-platform}
    volumes:
      - db-data:/var/lib/postgresql/data:rw

  mercure:
    image: dunglas/mercure
    labels:
      - "com.centurylinklabs.watchtower.enable=true"
    restart: always
    environment:
      - ALLOW_ANONYMOUS=${MERCURE_ALLOW_ANONYMOUS:?MERCURE_ALLOW_ANONYMOUS is not set or empty}
      - CORS_ALLOWED_ORIGINS=${MERCURE_CORS_ALLOWED_ORIGINS:?MERCURE_CORS_ALLOWED_ORIGINS is not set or empty}
      - JWT_KEY=${MERCURE_JWT_KEY:?MERCURE_JWT_KEY is not set or empty}
      - PUBLISH_ALLOWED_ORIGINS=${MERCURE_PUBLISH_ALLOWED_ORIGINS:?MERCURE_PUBLISH_ALLOWED_ORIGINS is not set or empty}
      - DEMO=${MERCURE_DEMO:?MERCURE_DEMO is not set or empty}
    ports:
      - target: 80
        published: 1337
        protocol: tcp

  client:
    image: ${CLIENT_IMAGE:?CLIENT_IMAGE is not set or empty}
    restart: always
    ports:
      - target: 80
        published: 3000
        protocol: tcp

  watchtower:
    command: --label-enable --cleanup --interval 300
    image: containrrr/watchtower
    labels:
      - "com.centurylinklabs.watchtower.enable=true"
    network_mode: none
    restart: always
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock

volumes:
  db-data: {}